/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001-2004
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  Rajnish Bhaskar <raj@lordofthemoon.com>
   -
   -
*/

///////////////////////////////////////////////////////////////////////////////
// Check if we are running stand-alone or as MultiZilla client
///////////////////////////////////////////////////////////////////////////////
function isMultiZillaRunning()
{
  var mzToolbar = document.getElementById("MultiZillaToolbar");
  if (mzToolbar)
    return mzToolbar;
  else return null;
}
///////////////////////////////////////////////////////////////////////////////
function initQPMmenu(qpmPopupMenu)
{
  var i = 0;
  var mzToolbar = isMultiZillaRunning();
  var menuItems = qpmPopupMenu.getElementsByAttribute("display", "hidden-tabbar");

  // Hide the <menuseparator> and the three extra <menuitem>'s
  for (i = 0; i < menuItems.length; i++) {
    menuItems[i].hidden = true;
  }
  if (mzToolbar) {
    var extraItems = 0;
    var mzToolbarHidden = (mzToolbar.getAttribute("hidden") == "true");
    // Loop from bottom to top and display the extra menu items when the MultiZilla 
    // toolbar is hidden, or when the toolbar button is hidden. The extra menuseparator 
    // will only be diplayed when one of the extra menu items is displayed.
    for (i = (menuItems.length-1); i > -1; i--) {
      if (mzToolbarHidden || (menuItems[i].id == "qpClearLocalDataMenu" && document.getElementById("privacymanager-tbbutton").hidden)) {
        menuItems[i].hidden = false;
      }
      if (mzToolbarHidden || (menuItems[i].id == "qpTabManager" && document.getElementById("tabmanager-tbbutton").hidden)) {
        menuItems[i].hidden = false;
        extraItems++;
      }
      else if (mzToolbarHidden || (menuItems[i].id == "qpSessionManager" && document.getElementById("sessionmanager-tbbutton").hidden)) {
        menuItems[i].hidden = false;
        extraItems++;
      }
      else if (mzToolbarHidden || (menuItems[i].id == "qpPermissionManager" && document.getElementById("permmanager-tbbutton").hidden)) {
        menuItems[i].hidden = false;
        extraItems++;
      }
      else if (extraItems && menuItems[i].localName == "menuseparator") {
        menuItems[i].hidden = false;
      }
    }
  } 
}
///////////////////////////////////////////////////////////////////////////////
function initGroupPref(menuElement)
{
  var prefGroup = menuElement.getAttribute("prefgroup");
  var prefElements = document.getElementsByAttribute("prefgroup", prefGroup);

  if (prefElements.length == 0)
    return;

  var prefType = prefElements[1].getAttribute("preftype");
  var prefDefval = prefElements[1].getAttribute("prefdefval");
  var prefIdentifier = prefElements[1].getAttribute("prefstring");
  var prefValue = readMyPref(prefIdentifier, prefType, 0, true);

  for (var i = 1; i < prefElements.length; i++) {
    if (prefElements[i].getAttribute("prefvalue") == prefValue) {
      prefElements[i].setAttribute("checked", "true");
      prefElements[i].setAttribute("disabled", "true");
    }
    else {
      prefElements[i].removeAttribute("checked");
      prefElements[i].removeAttribute("disabled");
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function changePref(menuElement, menuGroup, doRefresh)
{
  var prefType = menuElement.getAttribute("preftype");
  var prefIdentifier = menuElement.getAttribute("prefstring");
  var prefDefval = menuElement.getAttribute("prefdefval");
  var prefAttribute = null;
  var prefArray = new Array();
  var noAccess = "noAccess";
  var allAccess = "allAccess";
	
  if (prefIdentifier != null) {
    // retrieve current value
    var prefValue = readMyPref(prefIdentifier, prefType, prefDefval);

    if (prefType == "bool") // flip flop the pref
      writePref(prefType, prefIdentifier, !prefValue);
    else {
      if (menuGroup) // special case, use this value
        prefValue = menuElement.getAttribute("prefvalue");
      else { // used for int and string, other might follow
        prefAttribute = menuElement.getAttribute("prefattribute");

        if (prefAttribute == "checked") {
          // setup an array with values to use
          prefValues = eval(menuElement.getAttribute("prefvalue"));
          prefArray = prefValues;
          // pick the first or second value, based on the "checked" state
          prefValue = menuElement.getAttribute(prefAttribute) ? prefArray[1] : prefArray[0];
        }
        else
          prefValue = menuElement.getAttribute(prefAttribute);
      }
      // Ok, lets write this sucker
      writePref(prefType, prefIdentifier, prefValue);
    }
    if (doRefresh) // this pref setting needs a refresh
      getWebNavigation().reload(nsIWebNavigation.LOAD_FLAGS_IS_REFRESH);
  }
}
////////////////////////////////////////////////////////////////////////////////
function initQuickPrefs()
{
  var prefElements = document.getElementsByAttribute("pref", "true");

  for (var i = 0; i < prefElements.length; i++) {
    var prefId = prefElements[i].id;
    var prefType = prefElements[i].getAttribute("preftype");
    var prefIdentifier = prefElements[i].getAttribute("prefstring");
    var prefDefval = prefElements[i].getAttribute("prefdefval");
    var prefAttribute = prefElements[i].getAttribute("prefattribute");

    var prefValue = readMyPref(prefIdentifier, prefType, prefDefval);

    if (prefAttribute == "checked") {
      if (prefValue >= 1)
        prefElements[i].setAttribute(prefAttribute, "true");
      else 
        prefElements[i].removeAttribute(prefAttribute);
    }
    else 
      prefElements[i].setAttribute(prefAttribute, prefValue);
  }
}
////////////////////////////////////////////////////////////////////////////////
function initSelectedQPrefsMenu(element)
{
  permissionmanager = Components.classes["@mozilla.org/permissionmanager;1"]
                                .getService(Components.interfaces.nsIPermissionManager);
  popupmanager = Components.classes["@mozilla.org/PopupWindowManager;1"]
                           .getService(Components.interfaces.nsIPopupWindowManager);

  var permission, url;
  var IDs = new Array();
  var menuPopupID = element.getAttribute("prefgroup");
  var baseIDs = [ "qpmBlock-", "qpmAllow-", "qpmDefault-" ];

  if (menuPopupID != "install") {
    baseIDs[3] = "qpmSeparatorFor-";
  }
  for (i in baseIDs) {
    IDs[i] = baseIDs[i] + menuPopupID;
  }
  if (menuPopupID == "cookies") {
    var managePrivacySettings = document.getElementById("qpm_ManageCookiesPrivacySettings");

    if (readMyPref("network.cookie.cookieBehavior", "int", 3) == 3)
      managePrivacySettings.removeAttribute("hidden");
    else 
      managePrivacySettings.setAttribute("hidden", "true");
  }
  var uri = getBrowser().currentURI;
 
  if (gBrowser.selectedTab.hasAttribute("busy"))
    url = gBrowser.mCurrentTab.getAttribute("firstPage");
  else 
    url = gBrowser.mCurrentBrowser.webNavigation.currentURI.spec;

  permission = permissionmanager.testPermission(uri, menuPopupID.replace(/s$/, ''));
  // display radio dot for 'selected' menu item and disable it
  mzEnableElement(IDs[0], url, (permission == nsIPermissionManager.DENY_ACTION),
                  permission != nsIPermissionManager.DENY_ACTION);
  mzEnableElement(IDs[1], url, (permission == nsIPermissionManager.ALLOW_ACTION),
                  permission != nsIPermissionManager.ALLOW_ACTION)
  if (IDs.length >= 2 && IDs[2])
    mzEnableElement(IDs[2], url, (permission == nsIPermissionManager.UNKNOWN_ACTION),
                    permission != nsIPermissionManager.UNKNOWN_ACTION);
  if (IDs.length >= 3 && IDs[3])
    mzEnableElement(IDs[3], url, false, true);
}
///////////////////////////////////////////////////////////////////////////////
// This is a complete rewrite of enableElement() in cookieNavigatorOverlay.xul
// Note: all elements will be disabled for new (blank) tabs!
///////////////////////////////////////////////////////////////////////////////
function mzEnableElement(elementID, url, current, enabled)
{
  var element = document.getElementById(elementID);

  if (element) {
    // Do we need to display a radio dot for this element?
    if (current)
      element.setAttribute("currentPermission", "true"); // Yes we do!
    else
      element.removeAttribute("currentPermission"); // No, remove attribute

    if (enabled && url != "about:blank")
      element.removeAttribute("disabled");
    else
      element.setAttribute("disabled", "true");
  }
  else {
    throw("Unknown ID (" + elementID + ") used in function initSelectedQPrefsMenu()");
  }
}
///////////////////////////////////////////////////////////////////////////////
// This is a rewrite of aCookieImageAction() in cookieNavigatorOverlay.xul 
////////////////////////////////////////////////////////////////////////////////
function aCIPAction(element)
{
  var permissionmanager = Components.classes["@mozilla.org/permissionmanager;1"].getService(Components.interfaces.nsIPermissionManager);
  var action = element.getAttribute("for");
  var permission = element.getAttribute("permission");

  if (permission == "none")
    permission = nsIPermissionManager.UNKNOWN_ACTION;
  else 
    permission = (element.getAttribute("permission") == "true") ? nsIPermissionManager.ALLOW_ACTION : nsIPermissionManager.DENY_ACTION;

  var URI = getBrowser().currentURI;
  permissionmanager.add(URI, action, permission);

  var message = element.getAttribute("msg");
  setTimeout(alert, 0, message);
}
////////////////////////////////////////////////////////////////////////////////
function setUserAgentOverride(aEvent)
{
  var menuItemID = aEvent.getAttribute("id");
  var userAgentOverwriteID = "general.useragent.override";

  if (!/quickpref-/.test(menuItemID)) {
    var userAgent = aEvent.getAttribute("label");
    if (userAgent)
      writePref("char", userAgentOverwriteID, userAgent);
  }
  else {
    writePref("char", userAgentOverwriteID, "");
    pref.clearUserPref(userAgentOverwriteID);
  }
  loadURI("about:");
}
////////////////////////////////////////////////////////////////////////////////
function initRefSpoofingMenu(aElement)
{
  var refSetting = -1;
  var spoofURL = "http://ref.spoof.org/refspoof.cgi"; // default fake referrer
  var aWindow = gBrowser.contentWindow;
  var aDocument = aWindow.document;
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  try { 
    refSetting = pref.getIntPref("network.http.sendRefererHeader");
  } catch (ex) {
  }
  for (var i = 0; i < aElement.childNodes.length; i++) {
    aElement.childNodes[i].setAttribute("disabled", (refSetting == 0) ? "true" : "false");
    aElement.childNodes[i].setAttribute("checked", "false");
  }
  try {
    spoofURL = readMyPref("multizilla.refspoof.spoofurl", "string", spoofURL);
  } catch (ex) {
  }
  aElement.childNodes[6].setAttribute("label", qpmBundle.GetStringFromName("fake.label") + " " + spoofURL);
  aElement.childNodes[7].setAttribute("label", aDocument.referrer ?  
                                               qpmBundle.GetStringFromName("currentRef.label") + " " + aDocument.referrer : 
                                               qpmBundle.GetStringFromName("noRef.label"));

  if (refSetting)
    initGroupPref(aElement);
}
////////////////////////////////////////////////////////////////////////////////
function displayWarn(messageNumber)
{
  var msg = null;
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");

  switch(messageNumber) {
    case 0: msg = qpmBundle.GetStringFromName("refSpooferDisabled");
      break;
    case 1: msg = qpmBundle.GetStringFromName("refSpooferEnabled");
      break;
    case 2: msg = qpmBundle.GetStringFromName("refSpooferNone");
      break;
    case 3: msg = qpmBundle.GetStringFromName("illegalFakeReferrer");
      break;
    case 4:
    case 5: var spoofer = readMyPref("multizilla.refspoof.spoofing", "int", 1);
            msg = (spoofer == 1) ? qpmBundle.GetStringFromName("refSpooferDisabled") : qpmBundle.GetStringFromName("refSpooferEnabled");
      break;
  }
  if (msg)
    alert(msg);
}
////////////////////////////////////////////////////////////////////////////////
function manageFakeReferrer()
{
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  var dialogTitle = qpmBundle.GetStringFromName("fakeReferrerDialogTitle");
  var dialogText = qpmBundle.GetStringFromName("fakeReferrerDialogText");
  var fakeRefIsText = qpmBundle.GetStringFromName("fakeRefIsSetTo");
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
  var fakeReferrer = readMyPref("multizilla.refspoof.spoofurl", "url", "http://ref.spoof.org/refspoof.cgi");
  var result = {value:fakeReferrer};

  promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
  var ret = promptService.prompt(window, dialogTitle, dialogText, result, null, {value:0});

  if (ret && result.value && result.value != "") {
    alert(fakeRefIsText+result.value);
    writePref("string", "multizilla.refspoof.spoofurl", result.value);
  }
  else
    displayWarn(3);
}
////////////////////////////////////////////////////////////////////////////////
function openMZPrefWindow(aPanelID)
{
  aPanelID = aPanelID || "multiviews";
  goPreferences(aPanelID, "chrome://multiviews/content/pref/pref-multiviews.xul", "multiviews");
}
////////////////////////////////////////////////////////////////////////////////
function openPrefEditor()
{
  gBrowser.selectedTab = gBrowser.addOrGetTab("chrome://global/content/config.xul", null, null, null, true); 
  gBrowser.userTypedValue = ""; 
  SetPageProxyState("invalid", null);
}
////////////////////////////////////////////////////////////////////////////////
function onQPMClick(aEvent, aPopupID)
{
  if (aEvent.button == 0) {
    var i, menuitems;
    var popupNode = document.getElementById("quickpref-popup");

    if (aEvent.altKey) {
      openPrefEditor();
      return false;
    }
    else if (aEvent.metaKey || aEvent.ctrlKey) {
      var cachePopupNode = document.getElementById("quickpref-clearCachePopup");
      cachePopupNode.showPopup(cachePopupNode, aEvent.clientX, aEvent.clientY, "popup");
      return true;
    }
    else if (aEvent.shiftKey) {
      menuitems = popupNode.getElementsByAttribute("display", "menu");
      for (i = 0 ; i < menuitems.length; i++)
        menuitems[i].setAttribute("hidden", "true");
      popupNode.showPopup(popupNode, aEvent.clientX, aEvent.clientY, "popup");
      return false;
    }
    menuitems = popupNode.getElementsByAttribute("display", "menu");
    for (i = 0 ; i < menuitems.length; i++)
      menuitems[i].removeAttribute("hidden");
    popupNode.showPopup(popupNode, aEvent.clientX, aEvent.clientY, "popup");
	return true;
  }
  else if (aEvent.button == 1) 
    openMZPrefWindow();
  else if (aEvent.button == 2) {
    var context = aEvent.target.getAttribute("context");
    if (context) {
      var contextNode = document.getElementById(context);
      contextNode.showPopup(contextNode, aEvent.clientX, aEvent.clientY, "popup");
      return true;
    }
    else {
      askToDisableButton(aEvent);
      return true;
    }
  }
  return false;
}
////////////////////////////////////////////////////////////////////////////////
function initPackageMenuitems(menupopup)
{
  var installed = 0;
  var disabled = 0;
  var enabled = 0;

  for (var i = 4; i < menupopup.childNodes.length; i++) {
    installed++;    
    var packageName = menupopup.childNodes[i].getAttribute("packageName");
    var packageState = menupopup.childNodes[i].getAttribute("packageState");
    // dump("\npackageState: " + packageState);
    if (packageState == "true") // true is disabled!
      disabled++;
    else if (packageName != "multiviews")
      enabled++;
  }
  // dump("\ninstalled: " + installed + "\ndisabled: " + disabled + "\nenabled: " + enabled);
  var disableState = (installed == 1 || enabled == 0 || disabled == installed) ? "true" : "false";
  menupopup.childNodes[0].setAttribute("disabled", disableState); // 'Disable all Extensions'
  disableState = (installed == 1 || disabled == 0 || enabled == installed) ? "true" : "false";
  menupopup.childNodes[1].setAttribute("disabled", disableState); // 'Enable all Extensions'
}
////////////////////////////////////////////////////////////////////////////////
function mzTogglePackage(aEvent)
{
  var element = aEvent.originalTarget
  var stringBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  var packageName = element.getAttribute("packageName");
  var packageState = element.getAttribute("packageState");
  var packageStateText = packageState ? 'enable' : 'disable';
  packageStateText = stringBundle.GetStringFromName(packageStateText);
  var confirmationTitle = stringBundle.formatStringFromName('qpTogglePackageTitle', [packageStateText], 1);
  var confirmationText = stringBundle.formatStringFromName('qpTogglePackageText', [packageStateText], 1);

  if (!packageState && packageName == "multiviews") {
    if (!mzConfirmAction(confirmationTitle, confirmationText))
      return;
  }
  var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
  chromeRegistry.setAllowOverlaysForPackage(packageName.toLowerCase(), (packageState ? true : false));

  if (packageName == "multiviews")
    packageName = "MultiZilla";

  packageStateText = packageState ? 'enabled' : 'disabled';
  packageStateText = stringBundle.GetStringFromName(packageStateText);
  var argArray = [ packageName, packageStateText ];
  mzAlert(window, stringBundle.GetStringFromName('qpExtensionDialogTitle'), 
          stringBundle.formatStringFromName('extManagerMsg', argArray, 2));
}
////////////////////////////////////////////////////////////////////////////////
function mzAlert(aWindow, aTitle, aText)
{
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
  promptService.alert(aWindow, aTitle, aText);
}
////////////////////////////////////////////////////////////////////////////////
function mzSetAllExtensionsTo(menupopup, newState)
{
  var stringBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  var packageStateText = newState ? 'disable' : 'enable';
  packageStateText = stringBundle.GetStringFromName(packageStateText);
  var confirmationTitle = stringBundle.formatStringFromName('qpTogglePackagesTitle', [packageStateText], 1);
  var confirmationText = stringBundle.formatStringFromName('qpTogglePackagesText', [packageStateText], 1);

  if (!mzConfirmAction(confirmationTitle, confirmationText))
    return;

  var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
  var packages = new Array();
 
  for (var i = 4; i < menupopup.childNodes.length; i++) {
    var packageName = menupopup.childNodes[i].getAttribute("packageName");

    if (newState == true && packageName == "multiviews") {
      continue;
    }
    else {
      var packageState = (menupopup.childNodes[i].getAttribute("packageState") == "true");
      packageName = packageName.toLowerCase();
      // dump("\npackageName: " + packageName + " state: " + packageState + "\nnewState: " + newState);
      if (packageState != newState) {
        // dump("\nupdating packageName: " + packageName);
        chromeRegistry.setAllowOverlaysForPackage(packageName, !newState);
        packages.push(packageName);
      }
    }
  }
  if (packages.length > 0) {
    packages = String(packages).replace(/,/g, ', ');
    // dump("\npackages: " + packages);
    packageStateText = newState ? 'disabled' : 'enabled';
    packageStateText = stringBundle.GetStringFromName(packageStateText);
    mzAlert(window, stringBundle.GetStringFromName('qpExtensionDialogTitle'), 
            stringBundle.formatStringFromName('qpExtensionDialogText', [packageStateText, packages], 2));
  }
}
//////////////////////////////////////////////////////////////////////////
// I should group the following functions into one javascript 'class'
//////////////////////////////////////////////////////////////////////////
function mzConfirmAction(confirmationTitle, confirmationText)
{
  // dump("\nconfirmationTitle: " + confirmationTitle + "\nconfirmationText: " + confirmationText);
  var stringBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  var dialogTitle, dialogText;

  try {
    dialogTitle = stringBundle.GetStringFromName(confirmationTitle);
  } catch(ex) {
    dialogTitle = confirmationTitle;
  }
  try {
    dialogText = stringBundle.GetStringFromName(confirmationText);
  } catch(ex) {
    dialogText = confirmationText;
  }
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);

  return promptService.confirm(window, dialogTitle, dialogText);
}
//////////////////////////////////////////////////////////////////////////
function clearDiskMemCache()
{
  clearCache("BOTH");
}
////////////////////////////////////////////////////////////////////////////////
function clearAllBackTraces()
{
  clearGlobalHistory();
  clearUrlBarHistory();
  clearCache("BOTH");
}
////////////////////////////////////////////////////////////////////////////////
function clearGlobalHistory()
{
  var globalHistory;
  // Builds 20040210 and up (see also mozilla bug 224829) 
  if ("@mozilla.org/browser/global-history;2" in Components.classes)
    globalHistory = Components.classes["@mozilla.org/browser/global-history;2"];
  else 
    globalHistory = Components.classes["@mozilla.org/browser/global-history;1"];

  globalHistory = globalHistory.getService(Components.interfaces.nsIBrowserHistory);
  globalHistory.removeAllPages();
}
////////////////////////////////////////////////////////////////////////////////
function clearUrlBarHistory()
{
  // New implementation, this only works in Mozilla builds 20040602 and later
  // see also: https://bugzilla.mozilla.org/show_bug.cgi?id=245009
  writePref("char", "general.open_location.last_url", "")
  var localStore = RDF.GetDataSource("rdf:local-store");
  var urlBarHist = mzRDFCUtils.MakeSeq(localStore, RDF.GetResource("nc:urlbar-history"));

  for (var i = urlBarHist.GetCount(); i > 0; --i) {
    urlBarHist.RemoveElementAt(i, true);
  }
}
////////////////////////////////////////////////////////////////////////////////
// This function can be used to clear stored data for disk and/or mememory cache
////////////////////////////////////////////////////////////////////////////////
function clearCache(aCacheType)
{
  var classID = Components.classes["@mozilla.org/network/cache-service;1"];
  var cacheService = classID.getService(Components.interfaces.nsICacheService);

  if (aCacheType == "DISK")
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
  else if (aCacheType == "MEMORY")
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
  else { // "BOTH"
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
  }
}
////////////////////////////////////////////////////////////////////////////////
function mzClearAllCookies()
{
  const cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
                                  .getService(Components.interfaces.nsICookieManager);
  if (cookieManager)
    cookieManager.removeAll();
}
////////////////////////////////////////////////////////////////////////////////
// This clears all saved passwords. This is a serious action (dataloss at risk) 
// so we require the users confirmation, before doing anything. There's also a 
// pref "wallet.crypto" that can be used to encrypt sensitive data (passwords)
// But, we don't have to check this pref, because mozilla will take care of it!
////////////////////////////////////////////////////////////////////////////////
// http://lxr.mozilla.org/seamonkey/source/netwerk/base/public/nsIPasswordManager.idl
function mzClearAllPasswords()
{
  passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);

  var container = passwordManager.enumerator;
  var items = [];
  while (container.hasMoreElements()) {
    var item = container.getNext().QueryInterface(Components.interfaces.nsIPassword);
    items.push(item);
  }
  for (var i = 0; i < items.length; ++i)
    passwordManager.removeUser(items[i].host, items[i].user);
}
////////////////////////////////////////////////////////////////////////////////
// This removes all references from downloads.rdf. It took me quite some time, 
// but thanks to Neil, for the Start/EndBatchUpdate lines, this now also works.
////////////////////////////////////////////////////////////////////////////////
// http://lxr.mozilla.org/seamonkey/source/xpfe/components/download-manager/public/nsIDownloadManager.idl
function mzClearAllDownloads()
{
  var downloadManager = Components.classes["@mozilla.org/download-manager;1"].getService(Components.interfaces.nsIDownloadManager);
  // Construct the datasource from the filename, because I can't find it in the source!
  var datasource = getNewOrCurrentDSByFilename("downloads.rdf", false, null);
  var downloads = mzConstructRDFContainer(datasource, "seq", "NC:DownloadsRoot", false).GetElements(); 
  var downloadQueue = new Array();

  while (downloads.hasMoreElements()) {
    var item = downloads.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    downloadQueue.push(item);
  }
  downloadManager.startBatchUpdate();
  for (var i = 0; i < downloadQueue.length; i++) {
    try {
      downloadManager.removeDownload(downloadQueue[i].Value);
    } catch(ex) {
      dump("\nmzClearAllDownloads() failed to remove download data!");
    }
  }
  downloadManager.endBatchUpdate();
}
////////////////////////////////////////////////////////////////////////////////
// This should remove all form related data.
////////////////////////////////////////////////////////////////////////////////
// http://lxr.mozilla.org/seamonkey/source/extensions/wallet/signonviewer/nsISignonViewer.idl
// http://lxr.mozilla.org/seamonkey/source/extensions/wallet/public/nsIWalletService.idl
// chrome://communicator/content/wallet/WalletViewer.xul   Menu/Tools/Fill In Form
// chrome://communicator/content/wallet/WalletPreview.xul  Menu/Tools/Edit Form
// chrome://communicator/content/wallet/SignonViewer.xul   Menu/Tools/Form Manager
function mzClearAllFormData() 
{
  const walletViewerInterface = Components.classes["@mozilla.org/walleteditor/walleteditor-world;1"].createInstance(Components.interfaces.nsIWalletEditor);
  var list = walletViewerInterface.GetValue();

  if (list.length > 0) { // no data available or database locked!
    var BREAK = list[0];
    walletViewerInterface.SetValue("OK" + BREAK, window);
  }
}
////////////////////////////////////////////////////////////////////////////////
// This removes all locally stored data, including passwords so be very careful!
////////////////////////////////////////////////////////////////////////////////
function mzClearAllLocalData()
{
  /***
  * This can be used to clear all passwords and form data!
  * walletServiceInterface = Components.classes['@mozilla.org/wallet/wallet-service;1'].getService(Components.interfaces.nsIWalletService);
  * walletServiceInterface.WALLET_DeleteAll(); 
  */
  clearCache("ALL");
  clearUrlBarHistory()
  clearGlobalHistory();
  mzClearAllCookies();
  mzClearAllDownloads();
  mzClearAllFormData();
  mzClearAllPasswords();
}
////////////////////////////////////////////////////////////////////////////////
function openUserAgentManager()
{
  var uamIDs = [ "multizilla:uam-prefwindow", "multizilla:useragent-manager" ];

  for (i in uamIDs) {
    var dialogWin = getMostRecentWindow(uamIDs[i], false);

    if (dialogWin) {
      dialogWin.focus();
      break;
    }
    else {
      if (i == uamIDs.length-1) {
        window.openDialog("chrome://multiviews/content/useragent-manager/userAgentManager.xul", 
                          "userAgentManager", "chrome, dependent, modal, dialog, resizable=yes");

        break;
      }
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function clearAfterConfirmation(element)
{
  switch(element.id || element.observes) {
    case "ClearDiskMemoryCache":
      if (mzConfirmAction('qpClearMemDiskTitle', 'qpClearMemDiskText')) 
        clearDiskMemCache();
      break;
    case "ClearAllCache":
      if (mzConfirmAction('qpClearAllTitle', 'qpClearAllText')) 
        clearAllBackTraces();
      break;
    case "ClearAllCookies":
      if (mzConfirmAction('qpRemoveAllCookiesTitle', 'qpRemoveAllCookiesText')) 
        mzClearAllCookies();
      break;
    case "ClearAllForms":
      if (mzConfirmAction('qpClearAllFormDataTitle', 'qpClearAllFormDataText')) 
        mzClearAllFormData();
      break;
    case "ClearAllPasswords":
      if (mzConfirmAction('qpClearAllPasswordsTitle', 'qpClearAllPasswordsText')) 
        mzClearAllPasswords();
      break;
    case "ClearAllLocalData":
      if (mzConfirmAction('qpClearAllDataTitle', 'qpClearAllDataText')) 
        mzClearAllLocalData();
      break;
  }
}
////////////////////////////////////////////////////////////////////////////////
// This will be called menu 'Privacy Setting...' in quickPrefsMenuOverlay.xul
////////////////////////////////////////////////////////////////////////////////
function openPrivacySettings()
{
  goPreferences('multiviews', 'chrome://multiviews/content/pref/pref-multiviews.xul', 'mzPrivacy');
}
